
<template>
    <HeaderNavigation />
    <div class="btn-container">
        <input type="file" name="imgUpload" @change="onFichierUpload($event)">
        <button class="" @click="buttonUpload()">Publier l'image</button>
        <button class="" @click="deleteToken()">Se deconnecter</button>
        <button @click="testx()">click moi</button>
    </div>
    {{ success }}
    <div v-for="(image, idx) in images" :key="image" class="main-content">
        <div class="info-user-main">
            <img v-if="image.user.profil_picture == null" src="../assets/images/default_avatar.jpg" alt="" class="img-profil-modal">
            <p class="user-image">{{image.user.name}}</p>
            <i v-if="currentUser._id == image.user._id" @click="deleteImage(image._id, idx)" class="fa-solid fa-trash delete-image"></i>
        </div>
        <div class="image-container">
            <img :src="'http://localhost:3500/api/srcImage/' + image._id" class="img-accueil">
        </div>
        <!--<input type="text" v-model="imageComment[image._id]">-->

        <div class="under-image">
            <LikeImage
                :image="image"
                :idx="idx"
                @incrementLike="(like) => incrementLike(image._id, like)"
                @decrementLike="(like)=> decrementLike(image._id, like)"
            />
            <i class="fa-regular fa-comment icon-svg" @click="showModal(image._id, idx)"></i>
        </div>

        <CountLike
            :image="image"
        />
        <!--AFFICHER LES COMMENTAIRES-->
        <button v-if="image.commentaires.length > 0" class="show-comment-buttons" @click="showModal(image._id)">Afficher les commentaires</button>
        

        <!--APPELLE DU COMPOSANT MODALIMAGE-->
        <modalImage
            v-if="isModalVisible[image._id]"
            @close="closeModal(image._id)"
            :image="image"
            :idx="idx"
        />
        <GetPostedDate
        :image="image"
        />

    </div>
  <div v-for="user in users" :key="user">
    <router-link :to="'/profil/' + user._id">{{ user.name }}</router-link>
  </div>


</template>

<script>
/* eslint-disable */

import { useStore } from '../store/store';
import { mapState } from 'pinia'
import axios from 'axios';
// const { fetchCurrentUser } = useStore()

import modalImage from '@/components/modalImage.vue';
import CommentaireExist from '@/components/CommentaireExist.vue';
import LikeImage from '@/components/LikeImage.vue';
import CountLike from '@/components/CountLike.vue';
import GetPostedDate from '@/components/GetPostedDate.vue';
import HeaderNavigation from '@/components/headerNavigation.vue';
// import HeaderNavigation from '@/components/headerNavigation.vue';


export default {
    name: 'home',

components: {
    modalImage,
    CommentaireExist,
    LikeImage,
    CountLike,
    GetPostedDate,
    HeaderNavigation,
},

    data() {
        return {
            fichierUpload: null,
            name: "",
            src: "",
            images: [], 
            success: "",
            imageComment: {},
            isModalVisible: {},
        }
    },

    computed: {
        ...mapState(useStore, ['users']),
        ...mapState(useStore, ['currentUser']),
    },

    created(){

    // si l'utilisateur n'as pas de token, on l'empeche d'acceder a la page
    if(localStorage.getItem('token') == null){
            this.$router.push('/login')
    }

    // fetchCurrentUser(localStorage.getItem("user"));
    // on recupere le user connecté

    },

    async mounted(){
        const store = useStore();
        store.fetchUser();
        fetch('http://localhost:3500/api/images', {
            method: 'GET',
            headers: {
                    'authorization': 'Bearer ' + localStorage.getItem('token')
                }
            },)
         .then(response => response.json())
         .then(res => {
            res.map(image =>{
                this.images.push(image);
            })
         })
         .catch(err =>{
             console.log(err)
         })
    },

    methods: {
        testx(){

        },

        deleteToken() {
            localStorage.removeItem('token');
            localStorage.removeItem('user');
            this.$router.push('/login');
        },
        // FONCTION QUI PERMET DE RECUPERER L'IMAGE
        onFichierUpload(event) {
            this.fichierUpload = event.target.files[0];
            },
        // FONCTION QUI PERMET D'UPLOAD L'IMAGE
        buttonUpload() {
            const formData = new FormData();
            formData.append('file', this.fichierUpload);
            axios.post('http://localhost:3500/api/images', formData, {
                onUploadProgress: progressEvent => {
                    console.log("en cours d'upload " + Math.round(progressEvent.loaded / progressEvent.total) * 100);
                },
                headers: {
                    'Content-Type': 'multipart/form-data',
                    'authorization': 'Bearer ' + localStorage.getItem('token'),
                },
            },
            )
            .then(response => {
                console.log(response);
                console.log(response.data);
                this.images.push(response.data);
            })
            .catch(error => {
                console.log(error.response)
                this.error = error.response.data.message
            })
        },

        //OUVRIR OU FERMER MODAL
        showModal(id) {
            this.isModalVisible[id] = true;
        },
        closeModal(id) {
            this.isModalVisible[id] = false;
        },
        // ADD LIKE 
        incrementLike(imageId, like){
                const findImage = this.images.find(image => {
                return image._id === imageId
            })
            findImage.likes.push(like)
        },
        decrementLike(imageId, like){
            const findImage = this.images.find(image => {
              return image._id === imageId
            })
            const findIndex = findImage.likes.findIndex(likeId =>{
                return like === likeId
            })

            findImage.likes.splice(findIndex, 1)
        },
        deleteImage(id, index){
            axios.delete('http://localhost:3500/api/image/' + id)
            .then((res) => {
                this.images.splice(index, 1);
                console.log("bien suppr")
            })
            .catch(err => {
                console.log(err)
            })
        }
    }
       
}
</script>



<style>
    #app{
        display: flex;
        justify-content: center;
        flex-direction: column;
        height: auto !important;
    }
    .icon-svg{
        font-size: 1.5rem;
    }

</style>


<style scoped>

    .show-comment-buttons{
        border: none;
        cursor: pointer;
        width: auto;
        font-size: 1rem;
    }
    .btn-container{
        width: 10rem;
    }
    .main-content{
        display: flex;
        justify-content: flex-start;
        align-items: center;
        flex-direction: column;
        align-self: center;
        width: 25%;
        height: 35rem;
        border: 1px solid black;
        border-radius: 10px;
        margin-bottom: 1rem;
    }
    .info-user-main{
        display: flex;
        flex-direction: row;
        width: 100%;
        justify-self: start;
        border-bottom: 0.5px solid grey;
    }
    .image-container{
        height: 70%;
        display: flex;
        justify-content: center;
        align-items: center;
    }
    .user-image{
        align-self: center;
        margin-left: 10px;
    }
    .img-profil-modal{
        width: 10%;
        border-radius: 50%;
        margin: 10px;
    }
    .under-image{
        display: flex;
        justify-content: center;
        align-items: center;
        flex-direction: row;
        align-self: flex-start;
        margin-left: 2rem;
    }
    .img-accueil{
        width: 70%;
    }



    /* MEDIA QUERIES */
    
  @media only screen and (max-width: 600px){
    .main-content{
        width: 80%;
    }
  }
</style>